package sun.java2d.loops;

import java.awt.image.ColorModel;
import sun.font.GlyphList;
import sun.java2d.SunGraphics2D;
import java.awt.image.WritableRaster;
import sun.java2d.pipe.Region;
import sun.java2d.SurfaceData;

public final class GeneralRenderer
{
    static final int OUTCODE_TOP = 1;
    static final int OUTCODE_BOTTOM = 2;
    static final int OUTCODE_LEFT = 4;
    static final int OUTCODE_RIGHT = 8;
    
    public GeneralRenderer() {
    }
    
    public static void register() {
        Class<Object> clazz = GeneralRenderer.class;
        GraphicsPrimitiveMgr.register(new GraphicsPrimitive[] { new GraphicsPrimitiveProxy(clazz, "SetFillRectANY", FillRect.methodSignature, FillRect.primTypeID, SurfaceType.AnyColor, CompositeType.SrcNoEa, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "SetFillPathANY", FillPath.methodSignature, FillPath.primTypeID, SurfaceType.AnyColor, CompositeType.SrcNoEa, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "SetFillSpansANY", FillSpans.methodSignature, FillSpans.primTypeID, SurfaceType.AnyColor, CompositeType.SrcNoEa, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "SetDrawLineANY", DrawLine.methodSignature, DrawLine.primTypeID, SurfaceType.AnyColor, CompositeType.SrcNoEa, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "SetDrawPolygonsANY", DrawPolygons.methodSignature, DrawPolygons.primTypeID, SurfaceType.AnyColor, CompositeType.SrcNoEa, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "SetDrawPathANY", DrawPath.methodSignature, DrawPath.primTypeID, SurfaceType.AnyColor, CompositeType.SrcNoEa, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "SetDrawRectANY", DrawRect.methodSignature, DrawRect.primTypeID, SurfaceType.AnyColor, CompositeType.SrcNoEa, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorFillRectANY", FillRect.methodSignature, FillRect.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorFillPathANY", FillPath.methodSignature, FillPath.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorFillSpansANY", FillSpans.methodSignature, FillSpans.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorDrawLineANY", DrawLine.methodSignature, DrawLine.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorDrawPolygonsANY", DrawPolygons.methodSignature, DrawPolygons.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorDrawPathANY", DrawPath.methodSignature, DrawPath.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorDrawRectANY", DrawRect.methodSignature, DrawRect.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorDrawGlyphListANY", DrawGlyphList.methodSignature, DrawGlyphList.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any), new GraphicsPrimitiveProxy(clazz, "XorDrawGlyphListAAANY", DrawGlyphListAA.methodSignature, DrawGlyphListAA.primTypeID, SurfaceType.AnyColor, CompositeType.Xor, SurfaceType.Any) });
    }
    
    static void doDrawPoly(SurfaceData surfaceData, PixelWriter pixelWriter, int[] array, int[] array2, int n, int n2, Region region, int n3, int n4, boolean b) {
        int[] doDrawLine = null;
        if (n2 <= 0) {
            return;
        }
        int n6;
        int n5 = n6 = array[n] + n3;
        int n8;
        int n7 = n8 = array2[n] + n4;
        while (--n2 > 0) {
            ++n;
            int n9 = array[n] + n3;
            int n10 = array2[n] + n4;
            doDrawLine = doDrawLine(surfaceData, pixelWriter, doDrawLine, region, n5, n7, n9, n10);
            n5 = n9;
            n7 = n10;
        }
        if (b && (n5 != n6 || n7 != n8)) {
            doDrawLine(surfaceData, pixelWriter, doDrawLine, region, n5, n7, n6, n8);
        }
        return;
    }
    
    static void doSetRect(SurfaceData surfaceData, PixelWriter pixelWriter, int i, int j, int n, int n2) {
        pixelWriter.setRaster((WritableRaster)surfaceData.getRaster(i, j, n - i, n2 - j));
        while (j < n2) {
            for (; i < n; ++i) {
                pixelWriter.writePixel(i, j);
            }
            ++j;
        }
    }
    
    static int[] doDrawLine(SurfaceData surfaceData, PixelWriter pixelWriter, int[] array, Region region, int n, int n2, int n3, int n4) {
        if (array == null) {
            array = new int[8];
        }
        array[0] = n;
        array[1] = n2;
        array[2] = n3;
        array[3] = n4;
        if (!adjustLine(array, region.getLoX(), region.getLoY(), region.getHiX(), region.getHiY())) {
            return array;
        }
        int a = array[0];
        int a2 = array[1];
        int b = array[2];
        int b2 = array[3];
        pixelWriter.setRaster((WritableRaster)surfaceData.getRaster(Math.min(a, b), Math.min(a2, b2), Math.abs(a - b) + 1, Math.abs(a2 - b2) + 1));
        if (a == b) {
            if (a2 > b2) {
                do {
                    pixelWriter.writePixel(a, a2);
                } while (--a2 >= b2);
            }
            else {
                do {
                    pixelWriter.writePixel(a, a2);
                } while (++a2 <= b2);
            }
        }
        else if (a2 == b2) {
            if (a > b) {
                do {
                    pixelWriter.writePixel(a, a2);
                } while (--a >= b);
            }
            else {
                do {
                    pixelWriter.writePixel(a, a2);
                } while (++a <= b);
            }
        }
        else {
            int n5 = array[4];
            int n6 = array[5];
            int n7 = array[6];
            int n8 = array[7];
            int n9;
            int n10;
            int n11;
            int n12;
            int n13;
            int n14;
            if (n7 >= n8) {
                n9 = true;
                n10 = n8 * 2;
                n11 = n7 * 2;
                n12 = ((n5 < 0) ? -1 : 1);
                n13 = ((n6 < 0) ? -1 : 1);
                n7 = -n7;
                n14 = b - a;
            }
            else {
                n9 = false;
                n10 = n7 * 2;
                n11 = n8 * 2;
                n12 = ((n6 < 0) ? -1 : 1);
                n13 = ((n5 < 0) ? -1 : 1);
                n8 = -n8;
                n14 = b2 - a2;
            }
            int n15 = -(n11 / 2);
            if (a2 != n2) {
                int n16 = a2 - n2;
                if (n16 < 0) {
                    n16 = -n16;
                }
                n15 += n16 * n7 * 2;
            }
            if (a != n) {
                int n17 = a - n;
                if (n17 < 0) {
                    n17 = -n17;
                }
                n15 += n17 * n8 * 2;
            }
            if (n14 < 0) {
                n14 = -n14;
            }
            if (!(n9 == 0)) {
                do {
                    pixelWriter.writePixel(a, a2);
                    a += n12;
                    n15 += n10;
                    if (n15 >= 0) {
                        a2 += n13;
                        n15 -= n11;
                    }
                    else {
                        continue;
                    }
                } while (--n14 >= 0);
            }
            else {
                do {
                    pixelWriter.writePixel(a, a2);
                    a2 += n12;
                    n15 += n10;
                    if (n15 >= 0) {
                        a += n13;
                        n15 -= n11;
                    }
                    else {
                        continue;
                    }
                } while (--n14 >= 0);
            }
        }
        return array;
    }
    
    public static void doDrawRect(PixelWriter pixelWriter, SunGraphics2D sunGraphics2D, SurfaceData surfaceData, int n, int n2, int dim, int dim2) {
        if (dim < 0 || dim2 < 0) {
            return;
        }
        int dimAdd = Region.dimAdd(Region.dimAdd(n, dim), 1);
        int dimAdd2 = Region.dimAdd(Region.dimAdd(n2, dim2), 1);
        Region boundsIntersectionXYXY = sunGraphics2D.getCompClip().getBoundsIntersectionXYXY(n, n2, dimAdd, dimAdd2);
        if (boundsIntersectionXYXY.isEmpty()) {
            return;
        }
        int loX = boundsIntersectionXYXY.getLoX();
        int loY = boundsIntersectionXYXY.getLoY();
        int hiX = boundsIntersectionXYXY.getHiX();
        int hiY = boundsIntersectionXYXY.getHiY();
        if (dim < 2 || dim2 < 2) {
            doSetRect(surfaceData, pixelWriter, loX, loY, hiX, hiY);
            return;
        }
        if (loY == n2) {
            doSetRect(surfaceData, pixelWriter, loX, loY, hiX, loY + 1);
        }
        if (loX == n) {
            doSetRect(surfaceData, pixelWriter, loX, loY + 1, loX + 1, hiY - 1);
        }
        if (hiX == dimAdd) {
            doSetRect(surfaceData, pixelWriter, hiX - 1, loY + 1, hiX, hiY - 1);
        }
        if (hiY == dimAdd2) {
            doSetRect(surfaceData, pixelWriter, loX, hiY - 1, hiX, hiY);
        }
        return;
    }
    
    static void doDrawGlyphList(SurfaceData surfaceData, PixelWriter pixelWriter, GlyphList list, Region region) {
        int[] bounds = list.getBounds();
        region.clipBoxToBounds(bounds);
        int n = bounds[0];
        int n2 = bounds[1];
        int n3 = bounds[2];
        int n4 = bounds[3];
        pixelWriter.setRaster((WritableRaster)surfaceData.getRaster(n, n2, n3 - n, n4 - n2));
        for (int numGlyphs = list.getNumGlyphs(), i = 0; i < numGlyphs; ++i) {
            list.setGlyphIndex(i);
            int[] metrics = list.getMetrics();
            int j = metrics[0];
            int k = metrics[1];
            int n5 = metrics[2];
            int n6 = j + n5;
            int n7 = k + metrics[3];
            int n8 = 0;
            if (j < n) {
                n8 = n - j;
                j = n;
            }
            if (k < n2) {
                n8 += (n2 - k) * n5;
                k = n2;
            }
            if (n6 > n3) {
                n6 = n3;
            }
            if (n7 > n4) {
                n7 = n4;
            }
            if (n6 > j && n7 > k) {
                byte[] grayBits = list.getGrayBits();
                int n9;
                for (n9 = n5 - (n6 - j), ; k < n7; n8 += n9, ++k) {
                    for (; j < n6; ++j) {
                        if (grayBits[n8++] < 0) {
                            pixelWriter.writePixel(j, k);
                        }
                    }
                }
            }
        }
    }
    
    static int outcode(int n, int n2, int n3, int n4, int n5, int n6) {
        int n7;
        if (n2 < n4) {
            n7 = 1;
        }
        else if (n2 > n6) {
            n7 = 2;
        }
        else {
            n7 = 0;
        }
        if (n < n3) {
            n7 |= 0x4;
        }
        else if (n > n5) {
            n7 |= 0x8;
        }
        return n7;
    }
    
    public static boolean adjustLine(int[] array, int n, int n2, int n3, int n4) {
        int n5 = n3 - 1;
        int n6 = n4 - 1;
        int n7 = array[0];
        int n8 = array[1];
        int n9 = array[2];
        int n10 = array[3];
        if (n5 < n || n6 < n2) {
            return false;
        }
        if (n7 == n9) {
            if (n7 < n || n7 > n5) {
                return false;
            }
            if (n8 > n10) {
                n8 = (n10 = n10);
            }
            if (n8 < n2) {
                n8 = n2;
            }
            if (n10 > n6) {
                n10 = n6;
            }
            if (n8 > n10) {
                return false;
            }
            array[1] = n8;
            array[3] = n10;
        }
        else if (n8 == n10) {
            if (n8 < n2 || n8 > n6) {
                return false;
            }
            if (n7 > n9) {
                n7 = (n9 = n9);
            }
            if (n7 < n) {
                n7 = n;
            }
            if (n9 > n5) {
                n9 = n5;
            }
            if (n7 > n9) {
                return false;
            }
            array[0] = n7;
            array[2] = n9;
        }
        else {
            int n11 = n9 - n7;
            int n12 = n10 - n8;
            n11 = ((n11 < 0) ? (-n11) : n11);
            n12 = ((n12 < 0) ? (-n12) : n12);
            int n13 = n11 >= n12;
            int n14 = outcode(n7, n8, n, n2, n5, n6);
            int n15 = outcode(n9, n10, n, n2, n5, n6);
            while ((n14 | n15) != 0x0) {
                if ((n14 & n15) != 0x0) {
                    return false;
                }
                if (n14 != 0) {
                    if (0x0 != (n14 & 0x3)) {
                        if (0x0 != (n14 & 0x1)) {
                            n8 = n2;
                        }
                        else {
                            n8 = n6;
                        }
                        int n25 = n8 - array[1];
                        if (n25 < 0) {
                            n25 = -n25;
                        }
                        int n26 = 2 * n25 * n11 + n12;
                        if (!(n13 == 0)) {
                            n26 += n12 - n11 - 1;
                        }
                        int n27 = n26 / (2 * n12);
                        if (n11 < 0) {
                            n27 = -n27;
                        }
                        n7 = array[0] + n27;
                    }
                    else if (0x0 != (n14 & 0xC)) {
                        if (0x0 != (n14 & 0x4)) {
                            n7 = n;
                        }
                        else {
                            n7 = n5;
                        }
                        int n22 = n7 - array[0];
                        if (n22 < 0) {
                            n22 = -n22;
                        }
                        int n23 = 2 * n22 * n12 + n11;
                        if (n13 == 0) {
                            n23 += n11 - n12 - 1;
                        }
                        int n24 = n23 / (2 * n11);
                        if (n12 < 0) {
                            n24 = -n24;
                        }
                        n8 = array[1] + n24;
                    }
                    n14 = outcode(n7, n8, n, n2, n5, n6);
                }
                else {
                    if (0x0 != (n15 & 0x3)) {
                        if (0x0 != (n15 & 0x1)) {
                            n10 = n2;
                        }
                        else {
                            n10 = n6;
                        }
                        int n19 = n10 - array[3];
                        if (n19 < 0) {
                            n19 = -n19;
                        }
                        int n20 = 2 * n19 * n11 + n12;
                        if (!(n13 == 0)) {
                            n20 += n12 - n11;
                        }
                        else {
                            --n20;
                        }
                        int n21 = n20 / (2 * n12);
                        if (n11 > 0) {
                            n21 = -n21;
                        }
                        n9 = array[2] + n21;
                    }
                    else if (0x0 != (n15 & 0xC)) {
                        if (0x0 != (n15 & 0x4)) {
                            n9 = n;
                        }
                        else {
                            n9 = n5;
                        }
                        int n16 = n9 - array[2];
                        if (n16 < 0) {
                            n16 = -n16;
                        }
                        int n17 = 2 * n16 * n12 + n11;
                        if (!(n13 == 0)) {
                            --n17;
                        }
                        else {
                            n17 += n11 - n12;
                        }
                        int n18 = n17 / (2 * n11);
                        if (n12 > 0) {
                            n18 = -n18;
                        }
                        n10 = array[3] + n18;
                    }
                    n15 = outcode(n9, n10, n, n2, n5, n6);
                }
            }
            array[0] = n7;
            array[1] = n8;
            array[2] = n9;
            array[3] = n10;
            array[4] = n11;
            array[5] = n12;
            array[6] = n11;
            array[7] = n12;
        }
        return true;
    }
    
    static PixelWriter createSolidPixelWriter(SunGraphics2D sunGraphics2D, SurfaceData surfaceData) {
        return new SolidPixelWriter(surfaceData.getColorModel().getDataElements(sunGraphics2D.eargb, null));
    }
    
    static PixelWriter createXorPixelWriter(SunGraphics2D sunGraphics2D, SurfaceData surfaceData) {
        ColorModel colorModel = surfaceData.getColorModel();
        Object dataElements = colorModel.getDataElements(sunGraphics2D.eargb, null);
        Object dataElements2 = colorModel.getDataElements(((XORComposite)sunGraphics2D.getComposite()).getXorColor().getRGB(), null);
        switch (colorModel.getTransferType()) {
            case 0: {
                return new XorPixelWriter.ByteData(dataElements, dataElements2);
            }
            case 1:
            case 2: {
                return new XorPixelWriter.ShortData(dataElements, dataElements2);
            }
            case 3: {
                return new XorPixelWriter.IntData(dataElements, dataElements2);
            }
            case 4: {
                return new XorPixelWriter.FloatData(dataElements, dataElements2);
            }
            case 5: {
                return new XorPixelWriter.DoubleData(dataElements, dataElements2);
            }
            default: {
                throw new InternalError("Unsupported XOR pixel type");
            }
        }
    }
}
